"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.DEFAULT_PROPS = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n    animation: ", " ", "s linear infinite;\n  "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n  position: absolute;\n  width: 100%;\n  height: 100%;\n  ", "\n  border-top-color: transparent;\n  border-radius: 50%;\n  ", "\n\n  ", "\n  box-sizing: border-box;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n  position: absolute;\n  margin: auto;\n  left: 0;\n  right: 0;\n  top: 0;\n  bottom: 0;\n\n  ", "\n  ", "\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n  0% {\n    transform: translate(-50%, -50%) rotate(0deg);\n  }\n  to {\n    transform: translate(-50%, -50%) rotate(360deg);\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var DEFAULT_PROPS = {
  color: '#cccccc',
  strokeThickness: 5,
  size: 30,
  duration: 1
};
exports.DEFAULT_PROPS = DEFAULT_PROPS;
var rotate = (0, _styledComponents.keyframes)(_templateObject());

var LdsRolling = _styledComponents.default.div(_templateObject2(), function (_ref) {
  var size = _ref.size;
  return "\n    width: ".concat(size, "px;\n    height: ").concat(size, "px;\n  ");
}, function (_ref2) {
  var size = _ref2.size;
  return "\n    transform: translate(-".concat(size / 2, "px, -").concat(size / 2, "px) scale(1) translate(").concat(size / 2, "px, ").concat(size / 2, "px);\n  ");
});

var LdsRollingDiv = _styledComponents.default.div(_templateObject3(), function (_ref3) {
  var color = _ref3.color,
      strokeThickness = _ref3.strokeThickness;
  return "\n    border: ".concat(strokeThickness, "px solid ").concat(color, ";\n  ");
}, function (_ref4) {
  var duration = _ref4.duration;
  return (0, _styledComponents.css)(_templateObject4(), rotate, duration);
}, function (_ref5) {
  var size = _ref5.size;
  return "\n    top: ".concat(size / 2, "px;\n    left: ").concat(size / 2, "px;\n  ");
});

var Rolling = function Rolling(props) {
  var color = props.color,
      strokeThickness = props.strokeThickness,
      size = props.size,
      duration = props.duration;
  return _react.default.createElement(LdsRolling, {
    size: size
  }, _react.default.createElement(LdsRollingDiv, {
    strokeThickness: strokeThickness,
    color: color,
    size: size,
    duration: duration
  }));
};

Rolling.propTypes = {
  color: _propTypes.default.string,
  strokeThickness: _propTypes.default.number,
  size: _propTypes.default.number,
  duration: _propTypes.default.number
};
Rolling.defaultProps = DEFAULT_PROPS;
var _default = Rolling;
exports.default = _default;