"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _error = _interopRequireDefault(require("./components/error"));

var _loader = _interopRequireDefault(require("./components/loader"));

var _enhanced = _interopRequireDefault(require("./components/enhanced"));

var _default = function _default(WrappedComponent) {
  var ImageLoaderHOC =
  /*#__PURE__*/
  function (_PureComponent) {
    (0, _inherits2.default)(ImageLoaderHOC, _PureComponent);

    function ImageLoaderHOC(props) {
      var _this;

      (0, _classCallCheck2.default)(this, ImageLoaderHOC);
      _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ImageLoaderHOC).call(this, props));
      _this.state = {
        imageLoaded: false,
        imageError: false
      };
      _this._isMounted = false;
      _this.domImg = new window.Image();
      _this.setImageLoaded = _this.setImageLoaded.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
      _this.setImageError = _this.setImageError.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
      _this.resetState = _this.resetState.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
      _this.handleOnLoad = _this.handleOnLoad.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
      _this.handleOnError = _this.handleOnError.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
      _this.handleImageLoading = _this.handleImageLoading.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
      return _this;
    }

    (0, _createClass2.default)(ImageLoaderHOC, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this._isMounted = true;
        this.handleImageLoading();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        var src = this.props.src;

        if (src !== prevProps.src) {
          this.handleImageLoading();
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this._isMounted = false;
        this.domImg.src = '';
      }
    }, {
      key: "setImageLoaded",
      value: function setImageLoaded() {
        this.setState({
          imageLoaded: true
        });
      }
    }, {
      key: "setImageError",
      value: function setImageError() {
        this.setState({
          imageError: true
        });
      }
    }, {
      key: "resetState",
      value: function resetState() {
        this.setState({
          imageLoaded: false,
          imageError: false
        });
      }
    }, {
      key: "handleOnLoad",
      value: function handleOnLoad() {
        var onLoad = this.props.onLoad;

        if (this._isMounted) {
          this.setImageLoaded();
        }

        if (onLoad) {
          onLoad();
        }
      }
    }, {
      key: "handleOnError",
      value: function handleOnError(error) {
        var onError = this.props.onError;

        if (this._isMounted) {
          this.setImageError();
        }

        if (onError) {
          onError(error);
        }
      }
    }, {
      key: "handleImageLoading",
      value: function handleImageLoading() {
        var _this2 = this;

        var src = this.props.src;
        this.resetState();
        this.domImg.src = src;

        this.domImg.onload = function () {
          return _this2.handleOnLoad();
        };

        this.domImg.onerror = function () {
          return _this2.handleOnError();
        };
      }
    }, {
      key: "render",
      value: function render() {
        var _this$state = this.state,
            imageLoaded = _this$state.imageLoaded,
            imageError = _this$state.imageError;
        var _this$props = this.props,
            loaderComp = _this$props.loaderComp,
            errorComp = _this$props.errorComp,
            fadeIn = _this$props.fadeIn,
            rest = (0, _objectWithoutProperties2.default)(_this$props, ["loaderComp", "errorComp", "fadeIn"]);

        if (!imageLoaded && !imageError) {
          return _react.default.createElement(_loader.default, (0, _extends2.default)({
            component: loaderComp
          }, rest));
        }

        if (imageError) {
          return _react.default.createElement(_error.default, (0, _extends2.default)({
            component: errorComp
          }, rest));
        }

        return _react.default.createElement(_enhanced.default, (0, _extends2.default)({
          component: WrappedComponent,
          fadeIn: fadeIn
        }, rest));
      }
    }]);
    return ImageLoaderHOC;
  }(_react.PureComponent);

  ImageLoaderHOC.propTypes = {
    src: _propTypes.default.string.isRequired,
    onLoad: _propTypes.default.func,
    onError: _propTypes.default.func,
    loaderComp: _propTypes.default.node,
    errorComp: _propTypes.default.node,
    fadeIn: _propTypes.default.bool
  };
  ImageLoaderHOC.defaultProps = {
    onLoad: function onLoad() {},
    onError: function onError() {},
    loaderComp: null,
    errorComp: null,
    fadeIn: true
  };
  return ImageLoaderHOC;
};

exports.default = _default;